(function() {
    system.require('std/core/bind.em');
    
    // this function is serialized and executed on the scriptable entity
    function receiveFiles(){
        filesMap = {};
        required = {};
        system.print('In receiveFiles.\n');
        var origImport = system.import;
        var origRequire = system.require;
        system.import = function(filename) {
            if(filename in filesMap) {
                system.print('monkey importing ' + filename);
                eval(filesMap[filename]);
            } else {
                system.print('original-importing ' + filename);
                origImport.apply(system, arguments);
            }
        };
        system.require = function(filename) {
            if(filename in filesMap) {
                if(!(filename in required)) {
                    system.print('monkey requiring ' + filename);
                    eval(filesMap[filename]);
                    required[filename] = true;
                } else {
                    system.print('already monkey loaded: ' + filename);
                }
            } else {
                system.print('original-requiring ' + filename);
                origRequire.apply(system, arguments);
            }
        };
        scripter = system.createVisible(scripter);
       
        function readFN(sender,success) {
            if (success) 
                std.simpleStorage.readField('FDB',std.core.bind(readyFN, this, sender), {});
        }
        
        function readyFN(sender, readvalue) {
              filesMap = readvalue;
              {'FDBread':'success'} >> system.createVisible(sender) >> [];
              persistScript << [{'request':'script':},{'persist':true:}]<< system.createVisible(sender);
        }
        
        function readFDB() {
            system.require('std/shim/restore/simpleStorage.em');
            system.require('std/default.em');
            function readScript(FDB) {
                filesMap = FDB;
                std.simpleStorage.readField('persistScript',runScript, '');
            }
            
            function runScript(script) {
                required = {};
                system.print('In receiveFiles.\n');
                var origImport = system.import;
                var origRequire = system.require;
                system.import = function(filename) {
                    if(filename in filesMap) {
                        system.print('monkey importing ' + filename);
                        eval(filesMap[filename]);
                    } else {
                        system.print('original-importing ' + filename);
                        origImport.apply(system, arguments);
                    }
                };
                system.require = function(filename) {
                    if(filename in filesMap) {
                        if(!(filename in required)) {
                            system.print('monkey requiring ' + filename);
                            eval(filesMap[filename]);
                            required[filename] = true;
                        } else {
                            system.print('already monkey loaded: ' + filename);
                        }
                    } else {
                        system.print('original-requiring ' + filename);
                        origRequire.apply(system, arguments);
                    }
                };
                eval(script);   
            }
            
            std.simpleStorage.readField('FDB',readScript,{});
        }
          
        function persistScript(msg, sender) {
            std.simpleStorage.setScript(readFDB,false);
        }
    
        function setupDB(msg, sender) {
            system.require('std/shim/restore/simpleStorage.em');
            system.require('std/core/bind.em');
            
            std.simpleStorage.setField('FDB',msg.FDB, std.core.bind(readFN,this,sender.toString()));
        }
        
        {'request':'FDB'} >> scripter >> [setupDB, 30, function() {}];
    }

    // this stuff is executed on the requesting entity
    function createFileDB(fnames) {
        var FDB = {};
        for (var i=0; i<fnames.length; i++) {
            var fstring = system.__debugFileRead('../share/js/scripts/'+fnames[i]);
            system.print('\n\nRead file: '+fnames[i]+' = ' + fstring+'\n\n');
            FDB[fnames[i]]=fstring;
        }
        return FDB;
    }
    //Function executed first to set up everything on the client.  
    sendScript = function(target, fnames,script) {
        ///////////WHAT HAPPENING//////////////
        system.print('sendScript called. \n');
        var scriptString = @
            (function () {
                var scripter = '@ + system.self.toString() + @';
                @ + receiveFiles.toString() + @
                receiveFiles();
            })();
        @;
        ///////////////////////////////////////
        var request = {
            request : 'script',
            script: scriptString
        };
        var FDB = createFileDB(fnames);
        function(msg, sender) { sendFDB(FDB, script, msg, sender); } <<
            {'request':'FDB':} << target;
        request >> target >> [];
        system.print('Sent first script request\n');
    }
    function sendFDB(FDB, script, msg, target) {
            system.print('Got request for FDB\n');
            msg.makeReply({'FDB':FDB})>>[];
           //{'FDB':FDB}>>system.createVisible(target)>>[];
           std.core.bind(sendFinalScript,this,script)<<{'FDBread':'success':}<<target;
    }
    function sendFinalScript(fscript, msg, target) {
        system.print('Got request for final script request\n');
        system.print('Sending script:\n ' +fscript + '\n to: '+target.toString()+'\n');
        
        var request = {
            request: 'script',
            script: fscript,
            persist: true
        };
        request >> target >> [];
    }

})();


/*
How you would use the library:

var scriptToRun = @
    system.import('std/myGame.em');
    runMyGame();
@;

sendScript(simulator._selected, [
    'std/myGame.em',
    'std/myGame/uberCollision.em',
    'std/myGame/specialGUI.em'
], scriptToRun);

*/